// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// Copyright 2005 David le Roux

#include <QtGui>

#include "SolutionDialog.h"

void SolutionDialog::setSolutionStruct(SolutionStruct* s)
{
	solutionWidget->setSolutions(s);
}

SolutionDialog::SolutionDialog(QWidget* parent) : QDialog(parent)
{
	setMinimumSize(500,500);
	//setFixedSize(500,520);
	
	QPushButton *nextButton = new QPushButton(tr("Next"));
	label = new QLabel();
	solutionWidget = new SolutionWidget(label);
	connect(nextButton,SIGNAL(pressed()),solutionWidget,SLOT(nextSlot()));

	QScrollArea* scrollArea = new QScrollArea;
    scrollArea->setWidget(solutionWidget);
    scrollArea->setWidgetResizable(true);

	
	QHBoxLayout *buttonsLayout = new QHBoxLayout;
	//buttonsLayout->addStretch(1);
	buttonsLayout->addWidget(label);
	buttonsLayout->addWidget(nextButton);
	
	QVBoxLayout *verticalLayout = new QVBoxLayout;
//	horizontalLayout->addWidget(solutionWidget);
	verticalLayout->addWidget(scrollArea,1);

	QVBoxLayout *mainLayout = new QVBoxLayout;
	mainLayout->addLayout(buttonsLayout);
//	mainLayout->addStretch(1);
//	mainLayout->addSpacing(12);
	mainLayout->addLayout(verticalLayout);
	setLayout(mainLayout);

	setWindowTitle(tr("SudokuSAK - solutions"));
	
}
