// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// Copyright 2005 David le Roux

#ifndef _SOLUTIONWIDGET_H_
#define _SOLUTIONWIDGET_H_

#ifdef QT3
 #include <qfont.h>
 #include <qpoint.h>
 #include <qsize.h>
 #include <qstring.h>
 #include <qwidget.h>
#else
 #include <QFont>
 #include <QPoint>
 #include <QSize>
 #include <QString>
 #include <QWidget>
 #include <QStatusBar>
 #include <QLabel>
#endif
#include "SudokuSolver.h"

#include <vector>
using namespace std;


class QPaintEvent;

struct SimpleSquare
{
  int fix;
  SimpleSquare(int f)
  {
    fix = f;
  } 
}; 


class SolutionWidget : public QWidget
{
    Q_OBJECT

public:
    SolutionWidget(QLabel* l);
    void setSide(int s);
	void setSolutions(SolutionStruct* s);

	protected:
    void paintEvent(QPaintEvent *event);
    void resizeEvent ( QResizeEvent * event ) ;
//	QSize sizeHint() const;

	public slots:
		void nextSlot();
	
private:
    QFont displayFont;
    int side;
    int squareRootOfSide;
	int sideSquared;
    int squareWidth;
    int maxWidth;
    int squareHeight;
    int maxHeight;
 //   int cellWidth;
 //   int cellHeight;
 //   int fontSize;
    float bigFontSize;
    void calcFontSize();
   
    float fontSizeForRect(float haveWidth, float haveHeight);
  
    QRect squareToPaint(QPoint p);
    QRect squareToPaint(int row,int col);
    vector<QString> numbersAsStrings;
    SimpleSquare*** grid;
 
 	vector< vector<int> > solutions;
	//SolutionStruct* solutionStruct;
		
	void paintOnDevice(QPaintDevice* paintDevice,QRect rect);
	int solutionIndex;
	void updateGrid();
	void updateLabel();
	QLabel* label;
	
};
    
#endif
